#include <Windows.h>
#include <tchar.h>
#include "resource.h"

#define WM_STACKADDRESS		(WM_USER + 100)

ULONG_PTR *pAddresses = NULL;
UINT nAddresses = 0;

//
// Test Loop thread: not blocking for GUI
//

void TestLoop(ULONG_PTR p)
{
	UINT nExec = (UINT) p;

	STARTUPINFO si = { 0 };
	PROCESS_INFORMATION pi = { 0 };

	for (UINT x = 0; x < nExec; x++)
	{
		CreateProcess(_T("DynBaseApp.exe"), NULL, NULL, NULL, FALSE, 0,
			NULL, NULL, &si, &pi);

		WaitForSingleObject(pi.hProcess, 3000);
	}

	delete pAddresses;

	//
	// We're through with testing, show number of variations
	//

	TCHAR szMsg[100];

	wsprintf(szMsg, _T("The number of variations on %d executions is: %d."), 
		nExec, nAddresses);

	MessageBox(NULL, szMsg, _T("Test Result"), MB_ICONINFORMATION);

	ExitThread(0);
}

LRESULT CALLBACK DlgProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	

	switch (uMsg)
	{

	case WM_CLOSE:
		{
			EndDialog(hDlg, FALSE);
			break;
		}

	case WM_COMMAND:
		{
			switch ((WORD) wParam)
			{

			case IDC_TEST:
				{
					//
					// If executions != 0 start the loop
					//

					TCHAR nStrExec[20];

					GetDlgItemText(hDlg, ED_EXECUTIONS, nStrExec, 20);

					UINT nExec = _tcstoul(nStrExec, NULL, 10);

					if (nExec == 0) break;

					pAddresses = new ULONG_PTR [nExec];
					nAddresses = 0;

					CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE) &TestLoop, (LPVOID) 
						(ULONG_PTR) nExec, 0, NULL);

					break;
				}
			}

			break;
		}

	case WM_STACKADDRESS:
		{
			//
			// It's a stack address being sended by DynBaseApp.exe
			// add it to the list if not already there
			//

			ULONG_PTR Addr = (ULONG_PTR) lParam;

			for (UINT x = 0; x < nAddresses; x++)
			{
				if (Addr == pAddresses[x]) return FALSE;
			}

			pAddresses[nAddresses] = Addr;
			nAddresses++;

			break;
		}
	}

	return FALSE;
}

int APIENTRY _tWinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
					   LPTSTR lpCmdLine, int nCmdShow)
{
	return (int) DialogBox(hInstance, (LPCTSTR) IDD_RANDTEST, NULL, (DLGPROC) DlgProc);
}
