/*
Copyright (C) 2004 Jacquelin POTIER <jacquelin.potier@free.fr>
Dynamic aspect ratio code Copyright (C) 2004 Jacquelin POTIER <jacquelin.potier@free.fr>

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; version 2 of the License.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

//-----------------------------------------------------------------------------
// Object: class helper for listview control
//-----------------------------------------------------------------------------

#pragma once

// required lib : comctl32.lib
#pragma comment (lib,"comctl32")
// require manifest to make SetView work

#define _WIN32_WINNT 0x0501 // for xp os

#include <windows.h>
#include <commctrl.h>
#include <stdio.h>
#pragma warning (push)
#pragma warning(disable : 4005)// for '_stprintf' : macro redefinition in tchar.h
#include <TCHAR.h>
#pragma warning (pop)

#define CListview_MAX_STRING_ITEM_SIZE MAX_PATH
#define LIST_VIEW_TIMEOUT 5000

//////////////////////// structs //////////////////////// 
typedef struct _COLUMN_INFO
{
    TCHAR   pcName[MAX_PATH];
    int     iWidth;
    int     iTextAlign;
}COLUMN_INFO,*PCOLUMN_INFO;

class CListview
{
private:
    HWND hWndListView;
    // TCHAR replacement table for xml like loading saving
    TCHAR** ppszReplacedChar;
    HANDLE hevtUnlocked;

    void StrReplace(TCHAR* pszInputString,TCHAR* pszOutputString,TCHAR* pszOldStr,TCHAR* pszNewStr);
    void Convert(TCHAR* pszInputString,TCHAR* pszOutputString,BOOL bToXML);
public:
    CListview(HWND hWndListView);
    ~CListview();

    // Sets columns headers and some styles
    BOOL InitListViewColumns(int NbColumns,PCOLUMN_INFO pColumnInfo);
    // clear listview
    void Clear();
    // add item and sub items
    BOOL AddItemAndSubItems(int NbItem,TCHAR** ppcText);
    BOOL AddItemAndSubItems(int NbItem,TCHAR** ppcText,BOOL ScrollToItem);
    BOOL AddItemAndSubItems(int NbItem,TCHAR** ppcText,int ItemIndex,BOOL ScrollToItem);

    DWORD SetView(DWORD iView);
    void SetSelectedIndex(int ItemIndex);
    int GetSelectedIndex();
    BOOL IsItemSelected(int ItemIndex);
    void GetItemText(int ItemIndex,TCHAR* pcText,int pcTextMaxSize);
    void GetItemText(int ItemIndex,int SubItemIndex,TCHAR* pcText,int pcTextMaxSize);
    void SetItemText(int ItemIndex,TCHAR* pcText);
    void SetItemText(int ItemIndex,int SubItemIndex,TCHAR* pcText);
    void SetStyle(BOOL bFullRowSelect,BOOL bGridLines,BOOL bSendClickNotification);
    int GetItemCount();
    int GetColumnCount();
    HWND GetControlHandle();

    BOOL Save(TCHAR* pszFileName);
    BOOL Load(TCHAR* pszFileName);
    BOOL Save();
    BOOL Load();
};
