/*
Copyright (C) 2004 Jacquelin POTIER <jacquelin.potier@free.fr>
Dynamic aspect ratio code Copyright (C) 2004 Jacquelin POTIER <jacquelin.potier@free.fr>

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; version 2 of the License.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

//-----------------------------------------------------------------------------
// Object: PE helper
//-----------------------------------------------------------------------------

// require Imagehlp.lib
#pragma once
#include <windows.h>
#include <stdio.h>
#include <Imagehlp.h>
#include "../APIError/APIError.h"
#pragma warning (push)
#pragma warning(disable : 4005)// for '_stprintf' : macro redefinition in tchar.h
#include <TCHAR.h>
#pragma warning (pop)

// psapi lib is requiered
#pragma comment(lib,"Imagehlp")


// this class is just a begin of pe parsing we just interest us to the 3 first struct of an exe file
// that means IMAGE_DOS_HEADER IMAGE_NT_HEADERS PIMAGE_SECTION_HEADER

class CPE
{
private:
    BOOL ParseIMAGE_SECTION_HEADER();
    BOOL ParseIMAGE_NT_HEADERS();
    unsigned char* pBuffer;
    void ShowError(TCHAR* pcMsg);
    TCHAR pcFilename[MAX_PATH];
public:
    CPE(TCHAR* filename);
    ~CPE(void);
    BOOL Parse();
    BOOL SaveIMAGE_DOS_HEADER();
    BOOL SaveIMAGE_NT_HEADERS();
    BOOL SavePIMAGE_SECTION_HEADER();
    BOOL GetChecksum(DWORD* pCurrentHeaderCheckSum,DWORD* pRealCheckSum);
    BOOL CorrectChecksum();
    BOOL RawToRva(DWORD RawAddress,DWORD* pRvaAddress);
    BOOL RvaToRaw(DWORD RvaAddress,DWORD* pRawAddress);

    IMAGE_DOS_HEADER DosHeader;
    // NTHeader.OptionalHeader.DataDirectory index :
    //IMAGE_DIRECTORY_ENTRY_EXPORT          0 
    //IMAGE_DIRECTORY_ENTRY_IMPORT          1 
    //IMAGE_DIRECTORY_ENTRY_RESOURCE        2 
    //IMAGE_DIRECTORY_ENTRY_EXCEPTION       3 
    //IMAGE_DIRECTORY_ENTRY_SECURITY        4 
    //IMAGE_DIRECTORY_ENTRY_BASERELOC       5 
    //IMAGE_DIRECTORY_ENTRY_DEBUG           6 
    //IMAGE_DIRECTORY_ENTRY_COPYRIGHT       7 
    //IMAGE_DIRECTORY_ENTRY_ARCHITECTURE    7 
    //IMAGE_DIRECTORY_ENTRY_GLOBALPTR       8 
    //IMAGE_DIRECTORY_ENTRY_TLS             9 
    //IMAGE_DIRECTORY_ENTRY_LOAD_CONFIG    10 
    //IMAGE_DIRECTORY_ENTRY_BOUND_IMPORT   11 
    //IMAGE_DIRECTORY_ENTRY_IAT            12 
    //IMAGE_DIRECTORY_ENTRY_DELAY_IMPORT   13 
    //IMAGE_DIRECTORY_ENTRY_COM_DESCRIPTOR 14 
    IMAGE_NT_HEADERS NTHeader;

    // size of pSectionHeaders is in NTHeader.FileHeader.NumberOfSections
    PIMAGE_SECTION_HEADER pSectionHeaders;
};
