/*
Copyright (C) 2004 Jacquelin POTIER <jacquelin.potier@free.fr>
Dynamic aspect ratio code Copyright (C) 2004 Jacquelin POTIER <jacquelin.potier@free.fr>

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; version 2 of the License.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/


// to avoid rebasing, use the linker/advanced/BaseAddress option 


#include "../../GenericFakeAPI.h"
// You just need to edit this file to add new fake api 
// WARNING YOUR FAKE API MUST HAVE THE SAME PARAMETERS AND CALLING CONVENTION AS THE REAL ONE,
//                  ELSE YOU WILL GET STACK ERRORS

///////////////////////////////////////////////////////////////////////////////
// fake API prototype MUST HAVE THE SAME PARAMETERS 
// for the same calling convention see MSDN : 
// "Using a Microsoft modifier such as __cdecl on a data declaration is an outdated practice"
///////////////////////////////////////////////////////////////////////////////
int _cdecl mInternaAddSample(int a,int b);

///////////////////////////////////////////////////////////////////////////////
// fake API array. Redirection are defined here
///////////////////////////////////////////////////////////////////////////////
STRUCT_FAKE_API pArrayFakeAPI[]=
{
// library name ,function name, function handler, number of params (requiered to allocate enougth stack space)

// In this sample, as the address of the exe function depends on :
//          - debug or release mode 
//          - unicode use or not
// we have to use preprocessor defines, but if you look carefully you'll see that
// only one item is added in array for each build configuration
#if (defined(UNICODE)||defined(_UNICODE))
    #ifdef _DEBUG
        {_T("EXE_INTERNAL@0x411B70"),_T("add"),(FARPROC)mInternaAddSample,2},
    #else
        {_T("EXE_INTERNAL@0x401000"),_T("add"),(FARPROC)mInternaAddSample,2},
    #endif
#else
    #ifdef _DEBUG
        {_T("EXE_INTERNAL@0x411b30"),_T("add"),(FARPROC)mInternaAddSample,2},
    #else
        {_T("EXE_INTERNAL@0x401000"),_T("add"),(FARPROC)mInternaAddSample,2},
    #endif
#endif
    {_T(""),_T(""),NULL,0}// last element for ending loops
};

//-----------------------------------------------------------------------------
// Name: GetFakeAPIArray
// Object: allow calling module to get fake api array pointer
// Parameters :
//     in  : 
//     out : 
//     return : pArrayFakeAPI array struct previously defined
//-----------------------------------------------------------------------------
extern "C" __declspec(dllexport) void* __stdcall GetFakeAPIArray()
{
    return (void*)pArrayFakeAPI;
}

//-----------------------------------------------------------------------------
// Name: GetFakeAPIEncoding
// Object: allow calling module to know character encoding of pArrayFakeAPI
// Parameters :
//     in  : 
//     out : 
//     return : encoding type
//-----------------------------------------------------------------------------
extern "C" __declspec(dllexport) int __stdcall GetFakeAPIEncoding()
{
#if (defined(UNICODE)||defined(_UNICODE))
    return FakeAPIEncodingUNICODE;
#else
    return FakeAPIEncodingANSI;
#endif
}

///////////////////////////////////////////////////////////////////////////////
///////////////////////////// NEW API DEFINITION //////////////////////////////
/////////////////////// You don't need to export these functions //////////////
///////////////////////////////////////////////////////////////////////////////

int _cdecl mInternaAddSample(int a,int b) // _cdecl only if your internal func is _cdecl
{
    // make a mult instead of add
    return a*b;
}