#include <windows.h>
#include "../../GenericFakeAPI.h"
// You just need to edit this file to add new fake api 
// WARNING YOUR FAKE API MUST HAVE THE SAME PARAMETERS AND CALLING CONVENTION AS THE REAL ONE,
//                  ELSE YOU WILL GET STACK ERRORS

///////////////////////////////////////////////////////////////////////////////
// fake API prototype MUST HAVE THE SAME PARAMETERS 
// for the same calling convention see MSDN : 
// "Using a Microsoft modifier such as __cdecl on a data declaration is an outdated practice"
///////////////////////////////////////////////////////////////////////////////
BOOL WINAPI mIsDebuggerPresent(void);

///////////////////////////////////////////////////////////////////////////////
// fake API array. Redirection are defined here
///////////////////////////////////////////////////////////////////////////////
STRUCT_FAKE_API pArrayFakeAPI[]=
{
    // lib,func name,handler,param number (requiered to allocate enougth stack space)
    {_T("Kernel32.dll"),_T("IsDebuggerPresent"),(FARPROC)mIsDebuggerPresent,0},
    {_T(""),_T(""),NULL,0}// last element for ending loops
};

//-----------------------------------------------------------------------------
// Name: GetFakeAPIArray
// Object: allow calling module to get fake api array pointer
// Parameters :
//     in  : 
//     out : 
//     return : pArrayFakeAPI array struct previously defined
//-----------------------------------------------------------------------------
extern "C" __declspec(dllexport) void* __stdcall GetFakeAPIArray()
{
    return (void*)pArrayFakeAPI;
}

//-----------------------------------------------------------------------------
// Name: GetFakeAPIEncoding
// Object: allow calling module to know character encoding of pArrayFakeAPI
// Parameters :
//     in  : 
//     out : 
//     return : 
//-----------------------------------------------------------------------------
extern "C" __declspec(dllexport) int __stdcall GetFakeAPIEncoding()
{
#if (defined(UNICODE)||defined(_UNICODE))
    return FakeAPIEncodingUNICODE;
#else
    return FakeAPIEncodingANSI;
#endif
}

///////////////////////////////////////////////////////////////////////////////
///////////////////////////// NEW API DEFINITION //////////////////////////////
/////////////////////// You don't need to export these functions //////////////
///////////////////////////////////////////////////////////////////////////////
BOOL WINAPI mIsDebuggerPresent(void)
{
    return FALSE;
}

