
#ifndef IPaddrblock_H
#define IPaddrblock_H




class ipaddr_block
{
 public:
   int byte1;
   int byte2;
   int byte3;
   int byte4;
   int port;
   ipaddr_block();
   ipaddr_block(string ip);
   friend bool operator==(const ipaddr_block o1,const ipaddr_block o2);
   friend bool operator<(const ipaddr_block o1,const ipaddr_block o2);

};

ipaddr_block::ipaddr_block()
{
   byte1=0;
   byte2=0;
   byte3=0;
   byte4=0;
   port=0;
}

ipaddr_block::ipaddr_block(string ip)
{
	int index=0;
	int tempB=0;
	string tempS="";

	//extract the port number
	index=(int)ip.find(":");
	if(index!=string::npos)
	{
		tempS=ip.substr(index+1,ip.size());
		tempB=atoi(tempS.c_str());
		port=tempB;
		ip=ip.substr(0,index);
	}
	else port=0;

	//convert the dotted versione
	for(int i=1;i<=4;i++)
	{
		index=(int)ip.find(".");
		if(index!=string::npos)
		{
			tempS=ip.substr(0,index);
			tempB=atoi(tempS.c_str());
			switch(i)
			{
			  case 1:byte1=tempB;break;
			  case 2:byte2=tempB;break;
			  case 3:byte3=tempB;break;

			}

			ip=ip.substr(index+1,ip.size());

		}
		else 
		{
           tempB=atoi(ip.c_str());
		   byte4=tempB;
		}
		
	}
}

bool operator==(const ipaddr_block o1,const ipaddr_block o2)
{  
	if(	o1.byte1==o2.byte2 && o1.byte2==o2.byte2 && o1.byte3==o2.byte3 && o1.byte4==o2.byte4)
		return true;
	else return false;
}

bool operator<(const ipaddr_block o1,const ipaddr_block o2)
{
	if(o1.byte1<o2.byte1) return true;
	else if(o1.byte1==o2.byte2)
	{

		if(o1.byte2<o2.byte2) return true;
		else if(o1.byte2==o2.byte2){
	       if(o1.byte3<o2.byte3) return true;
		   else if(o1.byte3==o2.byte3)
		   {
			   if(o1.byte4<o2.byte4) return true;
			   else if(o1.byte4==o2.byte4)
			   {
				   if(o1.port<o2.port) return true;
				   else if(o1.port==o2.port) return false;
				   else return false;
			   }
			   else return false;
		   }
		   else return false;
		}
		else return false;
	}
	else return false;

}

#endif