#ifndef IPblock_H
#define IPblock_H

#include <map>
#include <iostream>
#include <list>
#include <string>
using namespace std;

class ipaddr_block
{
 public:
   int byte1;
   int byte2;
   int byte3;
   int byte4;
   int port;
   ipaddr_block();
   ipaddr_block(string ip);
   friend bool operator==(const ipaddr_block o1,const ipaddr_block o2);
   friend bool operator<(const ipaddr_block o1,const ipaddr_block o2);
};

ipaddr_block::ipaddr_block()
{
   byte1=0;
   byte2=0;
   byte3=0;
   byte4=0;
   port=0;
}

ipaddr_block::ipaddr_block(string ip)
{
	int index=0;
	int tempB=0;
	string tempS="";

	//extract the port number
	index=(int)ip.find(":");
	if(index!=string::npos)
	{
		tempS=ip.substr(index+1,ip.size());
		tempB=atoi(tempS.c_str());
		port=tempB;
		ip=ip.substr(0,index);
	}
	else port=0;

	//convert the dotted versione
	for(int i=1;i<=4;i++)
	{
		index=(int)ip.find(".");
		if(index!=string::npos)
		{
			tempS=ip.substr(0,index);
			tempB=atoi(tempS.c_str());
			switch(i)
			{
			  case 1:byte1=tempB;break;
			  case 2:byte2=tempB;break;
			  case 3:byte3=tempB;break;

			}

			ip=ip.substr(index+1,ip.size());

		}
		else 
		{
           tempB=atoi(ip.c_str());
		   byte4=tempB;
		}
		
	}
}

class IPelement{
public:
  ipaddr_block *IPnum;
  string IPstring;
public:
	IPelement();
	IPelement(string ip);
	IPelement(const struct sockaddr_in* to);
    string get_IPstring(){return IPstring;}
	const char* get_IPchar(){return IPstring.c_str();}
	ipaddr_block get_IPnum(){return *IPnum;}

};

IPelement::IPelement()
{
    IPstring=string("");
	IPnum=new ipaddr_block();
}
IPelement::IPelement(string ip)
{
    IPstring=ip;
	IPnum=new ipaddr_block(ip);
}

IPelement::IPelement(const struct sockaddr_in* to)
{
   IPnum=new ipaddr_block();
   IPnum->byte1=to->sin_addr.S_un.S_un_b.s_b1;
   IPnum->byte2=to->sin_addr.S_un.S_un_b.s_b2;
   IPnum->byte3=to->sin_addr.S_un.S_un_b.s_b3;
   IPnum->byte4=to->sin_addr.S_un.S_un_b.s_b4;
   IPnum->port=to->sin_port;

   IPstring=string(inet_ntoa(to->sin_addr));
}

class IPstream:public IPelement
{
private:
	long int num_packets;
public:
	IPstream(const struct sockaddr_in* to):IPelement(to){num_packets=0;}
	void inc(){num_packets++;}
	void dec(){num_packets--;}
};

bool operator==(const ipaddr_block o1,const ipaddr_block o2)
{  
	if(	o1.byte1==o2.byte2 && o1.byte2==o2.byte2 && o1.byte3==o2.byte3 && o1.byte4==o2.byte4)
		return true;
	else return false;
}

bool operator<(const ipaddr_block o1,const ipaddr_block o2)
{
	if(o1.byte1<o2.byte1) return true;
	else if(o1.byte2<o2.byte2) return true;
	else if(o1.byte3<o2.byte3) return true;
	else if(o1.byte4<o2.byte4) return true;
	else return false;
}

bool operator==(const IPelement &o1,const IPelement &o2)
{
	if(o1.IPnum==o2.IPnum)
       return true;
	else 
		return false;
}

map<ipaddr_block,IPelement> udplist;
map<ipaddr_block,IPelement> tcplist;

map<ipaddr_block,IPelement>::iterator pmap;



#endif
