

#ifndef filterLoadSave_H
#define filterLoadSave_H

#ifdef WIN32
#define _CRT_SECURE_NO_DEPRECATE
#endif

#include "xmlParser.h"
using namespace std;


string skypeXML("C:\\Documents and Settings\\epokh\\Application Data\\Skype\\shared.xml");

map<ipaddr_block,IPelement> filterlist;
map<ipaddr_block,IPelement> supernodelist;

class LoadSaveClass{

public:
	bool static loadIPfilter(string);
	bool static loadHostCache(string);
	bool static saveUDPstreamAsArff(string);
	bool static saveTCPstreamAsArff(string);
	bool static saveUDPstreamAsXML(string);
    
};

bool LoadSaveClass::loadIPfilter(string fileName)
{
	FILE *log=fopen( fileName.c_str(), "r+" );


   if( log != NULL )
   {
	   char line[100];
	   while(fgets(line,100,log))
	   {
       IPelement *IPelem=new IPelement(string(line));
	   filterlist.insert(pair<ipaddr_block,IPelement>(IPelem->get_IPnum(),*IPelem));
       OutputDebugStr("Element added to filter list");
	   OutputDebugStr(IPelem->get_IPchar());
	   }
      fclose( log );

	  return true;
   }
   else return false;

}

bool LoadSaveClass::loadHostCache(string fileName)
{
   
	// this open and parse the XML file:
  XMLNode xMainNode=XMLNode::openFileHelper(fileName.c_str(),"config");
 
  if(xMainNode.isEmpty())
  {
	  return false;
  }
  else
  {
  XMLNode xNode=xMainNode.getChildNode("lib");
  xNode=xNode.getChildNode("Connection");
  XMLNode xNodeHost=xNode.getChildNode("HostCache");

  int nhosts=xNodeHost.nChildNode();

  for(int i=1;i<=nhosts;i++)
  {
	  char temp[100];
	  string node_name("_");
	  itoa(i,temp,10);
	  node_name.append(temp);
	  xNode=xNodeHost.getChildNode(node_name.c_str());
	  IPelement *IPelem=new IPelement(string(xNode.getText()));
	  supernodelist.insert(pair<ipaddr_block,IPelement>(IPelem->get_IPnum(),*IPelem));
	  OutputDebugStr("Element host cache added to the list: ");
	  OutputDebugStr(IPelem->get_IPchar());

	  delete IPelem;

  } 
   return true;
  }

}


bool LoadSaveClass::saveUDPstreamAsArff(string fileName)
{
  	FILE *log=fopen( fileName.c_str(), "w+" );


   if( log != NULL )
   {

	   //write header
	   fprintf(log,"\n%s\n","\%Skype UDP stream log stats ");
	   fprintf(log,"\n@relation UDP_traffic\n");
	   fprintf(log,"\n@attribute UDP_IP_byte1 integer\n");
	   fprintf(log,"\n@attribute UDP_IP_byte2 integer\n");
	   fprintf(log,"\n@attribute UDP_IP_byte3 integer\n");
	   fprintf(log,"\n@attribute UDP_IP_byte4 integer\n");
	   fprintf(log,"\n@attribute UDP_IP_total_packet integer\n");
	   fprintf(log,"\n@attribute UDP_IP_total_packet_in integer\n");
	   fprintf(log,"\n@attribute UDP_IP_total_packet_out integer\n");
	   fprintf(log,"\n@attribute UDP_IP_port integer\n");
	   fprintf(log,"\n@attribute UDP_IP_is_super_node {Y,N}\n");
	   fprintf(log,"\n@data\n");

       map<ipaddr_block,IPstream>::iterator index;

	   for(index=udpstream.begin();index!=udpstream.end();index++)
	   {

		   if(index->second.isSuperNode==true)
			   fprintf(log,"\n %d,%d,%d,%d,%u,%u,%u,%d,%s \n",index->first.byte1,index->first.byte2,index->first.byte3,index->first.byte4,
			   index->second.get_num_packets(),index->second.get_total_packet("in"),index->second.get_total_packet("out"),index->second.IPnum->port,"Y" );
		   else
			   fprintf(log,"\n %d,%d,%d,%d,%u,%u,%u,%d,%s \n",index->first.byte1,index->first.byte2,index->first.byte3,index->first.byte4,
			   index->second.get_num_packets(),index->second.get_total_packet("in"),index->second.get_total_packet("out"),index->second.IPnum->port,"N" );


	   }

	   fclose( log );
       return true;
   }
   else return false;
}

   bool LoadSaveClass::saveTCPstreamAsArff(string fileName)
{
  	FILE *log=fopen( fileName.c_str(), "w+" );


   if( log != NULL )
   {

	   //write header
	   fprintf(log,"\n%s\n","\%Skype TCP stream log stats ");
	   fprintf(log,"\n@relation TCP_traffic\n");
	   fprintf(log,"\n@attribute TCP_IP_byte1 integer\n");
	   fprintf(log,"\n@attribute TCP_IP_byte2 integer\n");
	   fprintf(log,"\n@attribute TCP_IP_byte3 integer\n");
	   fprintf(log,"\n@attribute TCP_IP_byte4 integer\n");
	   fprintf(log,"\n@attribute TCP_IP_total_packet integer\n");
	   fprintf(log,"\n@attribute TCP_IP_total_in integer\n");
	   fprintf(log,"\n@attribute TCP_IP_total_out integer\n");
	   fprintf(log,"\n@attribute TCP_IP_port integer\n");
	   fprintf(log,"\n@attribute TCP_IP_is_super_node {Y,N}\n");
	   fprintf(log,"\n@data\n");

       map<ipaddr_block,TCPstream>::iterator index;

	   if(tcpstream.empty())
		  OutputDebugString("The tcpstream is empty!!");

	   for(index=tcpstream.begin();index!=tcpstream.end();index++)
	   {

		   if(index->second.isSuperNode==true)
			   fprintf(log,"\n %d,%d,%d,%d,%u,%u,%u,%d,%s \n",index->first.byte1,index->first.byte2,index->first.byte3,index->first.byte4,
			   index->second.get_num_packets(),index->second.get_total_packet("in"),index->second.get_total_packet("out"),index->second.IPnum->port,"Y" );
			 else
				 fprintf(log,"\n %d,%d,%d,%d,%u,%u,%u,%d,%s \n",index->first.byte1,index->first.byte2,index->first.byte3,index->first.byte4,
				 index->second.get_num_packets(),index->second.get_total_packet("in"),index->second.get_total_packet("out"),index->second.IPnum->port,"N" );

	   }

	   fclose( log );
       return true;
   }
   else return false;

}

bool LoadSaveClass::saveUDPstreamAsXML(string fileName)
{


	FILE *log=fopen( fileName.c_str(), "w+" );
    char *t;
	if(log!=NULL)
	{
		XMLNode xMainNode=XMLNode::createXMLTopNode();
		XMLNode xNode=xMainNode.addChild(stringDup("xml"),TRUE); 
		xNode.addAttribute(stringDup("version"),stringDup("1.0"));
		xNode=xNode.addChild(stringDup("Skype_UDP_log"));
		xNode.addAttribute(stringDup("timestamp"),stringDup("20/06/2006"));

		map<ipaddr_block,IPstream>::iterator index;

	  for(index=udpstream.begin();index!=udpstream.end();index++)
	   {
				   
			XMLNode xStream=xNode.addChild(stringDup("udp_stream_info"));
			xStream.addAttribute(stringDup("ip"),stringDup(index->second.get_IPchar()));

			string isSupernode;
			if(index->second.isSuperNode==true)
			  isSupernode=string("true");
			else
			  isSupernode=string("false");

			xStream.addAttribute(stringDup("total_packets"),stringDup(index->second.get_num_packets_str().c_str()));
			xStream.addAttribute(stringDup("is_supernode"),stringDup(isSupernode.c_str()));
			xStream.addAttribute(stringDup("total_packets_in"),stringDup(index->second.get_total_packet_str("in").c_str()));
			xStream.addAttribute(stringDup("total_packets_out"),stringDup(index->second.get_total_packet_str("out").c_str()));
            
			//magari ogni tot si potrebbe creare la stringa parziale xml e scriverla sul file

			list<infoPacket>::iterator pk_index;
			for(pk_index=index->second.packet_infos.begin();pk_index!=index->second.packet_infos.end();pk_index++)
			{
				XMLNode xNodeInfo=xStream.addChild("packet");
				xNodeInfo.addAttribute(stringDup("mode"),stringDup(pk_index->get_mode().c_str()));
				xNodeInfo.addAttribute(stringDup("port"),stringDup(pk_index->get_port_str().c_str()));
				xNodeInfo.addAttribute(stringDup("len"),stringDup(pk_index->get_len_str().c_str()));

			}
			


	   }

            int i=0;
			t=xMainNode.getChildNode(_T("Extension")).createXMLString(true,&i);
			t=xMainNode.createXMLString(true);

			fprintf(log,t);
			fclose(log);
			free(t);
			return true;
	}
	else return false;


}
#endif