/*
Copyright (C) 2004 Jacquelin POTIER <jacquelin.potier@free.fr>
Dynamic aspect ratio code Copyright (C) 2004 Jacquelin POTIER <jacquelin.potier@free.fr>

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; version 2 of the License.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#pragma once
#include <windows.h>
#pragma comment(lib,"ws2_32.lib") 
#include <map>
#include <iostream>
#include <list>
#include <string>
using namespace std;
#include "IPaddrblock.h"
#include "IPelem.h"
#include "IPstream.h"
#include "PacketManipulation.h"
//hashmap to follow udp and tcp connections!
//map<ipaddr_block,IPelement> udplist;
//map<ipaddr_block,IPelement> tcplist;
map<SOCKET,ipaddr_block> socket_list;
map<ipaddr_block,IPstream> udpstream;
map<ipaddr_block,TCPstream> tcpstream;
map<ipaddr_block,IPelement>::iterator pmap;
map<ipaddr_block,IPstream>::iterator pstream;
map<ipaddr_block,TCPstream>::iterator ptcpstream;

#include "filtersLoadSave.h"
#pragma warning (push)
#pragma warning(disable : 4005)// for '_stprintf' : macro redefinition in tchar.h
#include <TCHAR.h>
#pragma warning (pop)




// struct
typedef struct _STRUCT_FAKE_API
{
    TCHAR pszModuleName[MAX_PATH];
    TCHAR pszAPIName[MAX_PATH];
    FARPROC FakeAPI;

    BYTE ParamCount;// necessary for allocating enough stack size if you put a fake api without monitoring it

}STRUCT_FAKE_API,*PSTRUCT_FAKE_API;

enum tagFakeAPIEncoding
{
    FakeAPIEncodingANSI,
    FakeAPIEncodingUNICODE
};

typedef void* (__stdcall *tagGetFakeAPIArrayFuncPointer)(void);
typedef int (__stdcall *tagGetFakeAPIEncoding)(void);


///////////////////////////////////////////////////////////////////
// the two following structs are defined to allow a Unicode version of WinApiOverride to load an Ansi Fake DLL
// and an ANSI version of WinApiOverride to load an UNICODE fake dll
///////////////////////////////////////////////////////////////////
typedef struct _STRUCT_FAKE_API_ANSI
{
    char pszModuleName[MAX_PATH];
    char pszAPIName[MAX_PATH];
    FARPROC FakeAPI;
    BYTE ParamCount;
}STRUCT_FAKE_API_ANSI,*PSTRUCT_FAKE_API_ANSI;
typedef struct _STRUCT_FAKE_API_UNICODE
{
    wchar_t pszModuleName[MAX_PATH];
    wchar_t pszAPIName[MAX_PATH];
    FARPROC FakeAPI;
    BYTE ParamCount;
}STRUCT_FAKE_API_UNICODE,*PSTRUCT_FAKE_API_UNICODE;

//__declspec( dllexport )  BOOL WINAPI DllMain(HINSTANCE hinstDLL, DWORD fdwReason, LPVOID lpvReserved);