#include "DynamicMessageBox.h"

typedef int (__stdcall *tagMessageBox)(IN HWND hWnd,IN TCHAR* lpText,IN TCHAR* lpCaption,IN UINT uType);
HMODULE hModUser32=NULL;
tagMessageBox pMessageBox=NULL;

// avoid to load library user32.dll until not requiered
int DynamicMessageBox(IN HWND hWnd,IN TCHAR* lpText,IN TCHAR* lpCaption,IN UINT uType)
{
    // get proc address of DynamicMessageBox func
    if (!pMessageBox)
    {
        // if we don't have a handle to user32.dll try to get it
        if (!hModUser32)
        {
            hModUser32=GetModuleHandle(_T("user32.dll"));
            if (!hModUser32)// if user32.dll was not loaded
            {
                hModUser32=LoadLibrary(_T("user32.dll"));
                if(!hModUser32)
                    return -1;
            }
        }
#if (defined(UNICODE)||(_UNICODE))
        pMessageBox=(tagMessageBox)GetProcAddress(hModUser32,"MessageBoxW");
#else
        pMessageBox=(tagMessageBox)GetProcAddress(hModUser32,"MessageBoxA");
#endif
        if (!pMessageBox)
            return -1;
    }
    // now pMessageBox is ok
    return pMessageBox(hWnd,lpText,lpCaption,uType);
}