/*
Copyright (C) 2004 Jacquelin POTIER <jacquelin.potier@free.fr>
Dynamic aspect ratio code Copyright (C) 2004 Jacquelin POTIER <jacquelin.potier@free.fr>
originaly based from APISpy32 v2.1 from Yariv Kaplan @ WWW.INTERNALS.COM

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; version 2 of the License.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#include "LogAPI.h"

extern CMailSlotClient* pMailSlotClt;

//-----------------------------------------------------------------------------
// Name: AddLogEntry
// Object: write log informations to logging mailslot
// Parameters :
//     in : DWORD dwProcessId : process id
//          TCHAR* pszModuleName : dll name
//          TCHAR* pszAPIName : api name with params value
//          DWORD dwReturnValue : return address
//          PVOID pvOriginAddress : original address
//          int iParametersType : specify parameter log direction type
// Return : TRUE on success, FALSE on error
//-----------------------------------------------------------------------------
BOOL AddLogEntry(DWORD dwProcessId, TCHAR* pszModuleName, TCHAR* pszAPIName, DWORD dwReturnValue, PVOID pvOriginAddress,int iParametersType)
{
    BOOL bResult;
    DWORD dw;
    tagLogEntry LogEntry;

    // fill tagLogEntry struct
    LogEntry.dwProcessId = dwProcessId;
    LogEntry.dwReturnValue = dwReturnValue;
    LogEntry.pvOriginAddress = pvOriginAddress;
    LogEntry.bParamDirectionType=(BYTE)iParametersType;
    _tcsncpy(LogEntry.szModuleName,pszModuleName,MAX_PATH);
    _tcsncpy(LogEntry.szAPINameAndParams, pszAPIName,MAX_PATH-1);
    LogEntry.szAPINameAndParams[MAX_PATH-1]=0;

    // put in buffer command_value and LogEntry
    PBYTE pb=new BYTE[sizeof(DWORD)+sizeof(tagLogEntry)];
    // put command value
    dw=CMD_MONITORING_LOG;
    memcpy(pb,&dw,sizeof(DWORD));
    // put log entry
    memcpy(&pb[sizeof(DWORD)],&LogEntry,sizeof(tagLogEntry));
    // transmit struct to remote process
    bResult=pMailSlotClt->Write(pb, sizeof(DWORD)+sizeof(tagLogEntry));
    delete pb;

    return bResult;
}