/*
Copyright (C) 2004 Jacquelin POTIER <jacquelin.potier@free.fr>
Dynamic aspect ratio code Copyright (C) 2004 Jacquelin POTIER <jacquelin.potier@free.fr>

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; version 2 of the License.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.



This Class has been written thanks to the very good
WinSpy Project Copyright (c) by 2003 Robert Kuster
*/



//////////// WARNING //////////////////////////////
// Code injection will only work in release Mode
//////////// WARNING /////////////////////////////
#pragma once

#include <windows.h>



class CCodeInject
{
private:
    typedef HMODULE (WINAPI *pfGetModuleHandleA)(char* lpModuleName);
    typedef HMODULE (WINAPI *pfLoadLibraryA)(char* lpModuleName);
    typedef FARPROC (WINAPI *pfGetProcAddressA)(HMODULE hModule,char* lpProcName);
    typedef BOOL (WINAPI *pfFreeLibrary)(HMODULE hModule);

    typedef struct tagGETMODULEHANDLE_PARAM
    {
        pfGetModuleHandleA	pGetModuleHandleA;
        pfLoadLibraryA      pLoadLibraryA;
        char                pszDllName[MAX_PATH];// dll name to retreive hmodule
        HMODULE             RemotehModule;// return value of get modulehandle or loadlibrary
        BOOL                bFreeLibraryShoudBeCall;// TRUE if loadlibrary as been called
    }GETMODULEHANDLE_PARAM,*PGETMODULEHANDLE_PARAM;

    typedef struct tagGETPROCADDRESS_PARAM
    {
        pfGetProcAddressA   pGetProcAddressA;
        HMODULE             hModule;// dll hmodule
        char                pszProcName[MAX_PATH];// function name
        FARPROC             RemotepFunction;// return value of GetProcAddress
    }GETPROCADDRESS_PARAM,*PGETPROCADDRESS_PARAM;

    typedef struct tagFREELIBRARY_PARAM
    {
        pfFreeLibrary       pFreeLibrary;
        HMODULE             hModule;
    }FREELIBRARY_PARAM,*PFREELIBRARY_PARAM;


    DWORD dwPageSize;

    LPVOID       pDataRemote;    // the address (in the remote process) of param data;
    FARPROC      pCodeRemote;    // the address (in the remote process) where ThreadFunc will be copied to;
    HANDLE       hProcess;

    LPVOID       pDataRemoteBackup;
    FARPROC      pCodeRemoteBackup;

    pfLoadLibraryA      pLoadLibraryA;
    pfGetModuleHandleA  pGetModuleHandleA;
    pfGetProcAddressA   pGetProcAddressA;
    pfFreeLibrary       pFreeLibrary;

    void SaveRemotePointers();
    void RestoreRemotePointers();
    void FreeRemoteAllocatedMemory();

    friend static DWORD WINAPI RemoteGetModuleHandleThreadProc (CCodeInject::PGETMODULEHANDLE_PARAM lpParameter);
    friend static DWORD WINAPI RemoteFreeLibraryThreadProc (CCodeInject::PFREELIBRARY_PARAM lpParameter);
    friend static DWORD WINAPI RemoteGetProcAddressThreadProc (CCodeInject::PGETPROCADDRESS_PARAM lpParameter);

public:
    CCodeInject(HANDLE hProcess);
    ~CCodeInject(void);
    BOOL SetParameter(PVOID Param,SIZE_T ParamSize);
    BOOL GetParameter(PVOID Param,SIZE_T ParamSize);
    BOOL SetCode(FARPROC ThreadProcStartAdress,DWORD dwThreadProcCodeSize);
    BOOL Execute();
    BOOL Execute(LPDWORD lpExitCode);
    BOOL Execute(FARPROC RemoteProcFuncAddress,LPDWORD lpExitCode);

    BOOL RemoteGetModuleHandle(char* pszDllName,HMODULE* phModule,BOOL* pbFreeLibraryShoudBeCall);
    BOOL RemoteGetProcAddress(HMODULE hModule,char* pszProcName,FARPROC* ppFunc);
    BOOL RemoteFreeLibrary(HMODULE hModule);
};
