/*
Copyright (C) 2004 Jacquelin POTIER <jacquelin.potier@free.fr>
Dynamic aspect ratio code Copyright (C) 2004 Jacquelin POTIER <jacquelin.potier@free.fr>

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; version 2 of the License.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

//-----------------------------------------------------------------------------
// Object: class helper for reading or writing process memory
//-----------------------------------------------------------------------------

#include "processmemory.h"

CProcessMemory::CProcessMemory(DWORD dwProcessID,BOOL bReadOnly)
{
    this->dwProcessID=dwProcessID;
    if (bReadOnly)
        this->dwDesiredAccess=PROCESS_VM_READ;//|PROCESS_QUERY_INFORMATION;
    else
        this->dwDesiredAccess=PROCESS_VM_READ|PROCESS_VM_WRITE|PROCESS_VM_OPERATION;//PROCESS_ALL_ACCESS;

    this->hProcess = OpenProcess(this->dwDesiredAccess,FALSE,this->dwProcessID);
    if (!this->hProcess)
    {
        TCHAR szMessage[MAX_PATH];
        TCHAR szError[MAX_PATH];
        DWORD dwLastError=GetLastError();
        DWORD dw=FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM,
                           NULL,
                           dwLastError,
                           GetSystemDefaultLangID(),//GetUserDefaultLangID()
                           szError,
                           sizeof(szError)-1,
                           NULL);
        if (dw)
        {
            _stprintf(szMessage,
                _T("The following error as occured when trying to opening process with pid %u\r\n%s"),
                this->dwProcessID,
                szError);
        }
        else
        {
            _stprintf(szMessage,
                _T("The error number %u as occured when trying to opening process with pid %u"),
                dwLastError,
                this->dwProcessID
                );
        }
        MessageBox(NULL,szMessage,_T("Error"),MB_OK|MB_ICONERROR);
    }
}

CProcessMemory::~CProcessMemory(void)
{
    CloseHandle(this->hProcess);
}
// on error just call the GetSystemInfo and use SYSTEM_INFO.dwPageSize
// to make a loop with VirtualQueryEx
BOOL CProcessMemory::Read(LPCVOID lpBaseAddress,LPVOID lpBuffer,SIZE_T nSize,SIZE_T* lpNumberOfBytesRead)
{
    return ReadProcessMemory(this->hProcess,lpBaseAddress,lpBuffer,nSize,lpNumberOfBytesRead);
}
// on error just call the GetSystemInfo and use SYSTEM_INFO.dwPageSize
// to make a loop with VirtualQueryEx
BOOL CProcessMemory::Write(LPVOID lpBaseAddress,LPCVOID lpBuffer,SIZE_T nSize,SIZE_T* lpNumberOfBytesWritten)
{
    return WriteProcessMemory(this->hProcess,lpBaseAddress,lpBuffer,nSize,lpNumberOfBytesWritten);
}