// thx to A. Miguel Feijao and MSDN

#pragma once

#include <windows.h>
#include <tlhelp32.h>
#ifndef _WIN32_WINNT
#define _WIN32_WINNT 0x0500
#endif
#include <Winternl.h>

#include "Struct.h"
#include "../../APIError/APIError.h"
typedef NTSTATUS (WINAPI *ptrNtQueryInformationThread) (
        IN HANDLE ThreadHandle,
        IN THREADINFOCLASS ThreadInformationClass,
        OUT PVOID ThreadInformation,
        IN ULONG ThreadInformationLength,
        OUT PULONG ReturnLength OPTIONAL
        );
typedef NTSTATUS (WINAPI *ptrNtQueryInformationProcess) (
    IN HANDLE ProcessHandle,
    IN PROCESSINFOCLASS ProcessInformationClass,
    OUT PVOID ProcessInformation,
    IN ULONG ProcessInformationLength,
    OUT PULONG ReturnLength OPTIONAL
    );
typedef ULONG (WINAPI *ptrRtlNtStatusToDosError)(NTSTATUS Status);

typedef DWORD (WINAPI *ptrGetProcessIdOfThread)(HANDLE Thread);
typedef DWORD (WINAPI *ptrGetThreadId)(HANDLE Thread);
typedef DWORD (WINAPI *ptrGetProcessId)(HANDLE Process);

class CProcessAndThreadID
{
private:
    BOOL NtDllLibLoaded;
    BOOL Kernel32LibLoaded;
    HMODULE hModuleNtDll;
    HMODULE hModuleKernel32;
    ptrNtQueryInformationThread pNtQueryInformationThread;
    ptrRtlNtStatusToDosError pRtlNtStatusToDosError;
    ptrNtQueryInformationProcess pNtQueryInformationProcess;

    ptrGetProcessIdOfThread pGetProcessIdOfThread;
    ptrGetThreadId pGetThreadId;
    ptrGetProcessId pGetProcessId;

    DWORD GetProcessIdOfThreadOldOS(HANDLE hThread);
    DWORD GetThreadIdOldOS(HANDLE hThread);
    DWORD GetProcessIdOldOS(HANDLE hProcess);
public:
    CProcessAndThreadID();
    ~CProcessAndThreadID();

    DWORD GetProcessIdOfThread(HANDLE hThread);
    DWORD GetThreadId(HANDLE hThread);
    DWORD GetProcessId(HANDLE hProcess);
};
