/*
Copyright (C) 2004 Jacquelin POTIER <jacquelin.potier@free.fr>
Dynamic aspect ratio code Copyright (C) 2004 Jacquelin POTIER <jacquelin.potier@free.fr>

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; version 2 of the License.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

//-----------------------------------------------------------------------------
// Object: manages the filters dialog
//-----------------------------------------------------------------------------

#pragma once

#include <windows.h>
#include <Psapi.h>
#include <stdio.h>
// psapi lib is requiered
#pragma comment(lib,"psapi")

#include "resource.h"
#include "../Tools/GUI/Dialog/DialogHelper.h"
#include "../tools/GUI/ListBox/Listbox.h"
#include "../Tools/String/WildCharCompare.h"
#include "../Tools/String/MultipleElementsParsing.h"
#include "../tools/Process/ProcessHelper/ProcessHelper.h"


#define FILTERS_INACTIVE_PROCESSES_PID  0 // Inactive Processes PID not a hookable process
#define FILTERS_SYSTEM_PID              4 // System PID not a hookable process

#define FILTERS_NB_MAX_PROCESSES        1024 // nb max process

// ShowFilterDialog results
#define FILTERS_DLG_RES_FAILED 0
#define FILTERS_DLG_RES_OK     1    // user clicks OK
#define FILTERS_DLG_RES_CANCEL 2    // user clicks Cancel

LRESULT CALLBACK FiltersWndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
class CFilters
{
friend LRESULT CALLBACK FiltersWndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);

private:
    HWND hWndFiltersDialog;
    HWND hwndFilterDialogListBox;

    DWORD* pdwFiltersParentPorcessID;
    DWORD pdwFiltersParentPorcessIDSize;
    TCHAR** pszFiltersInclusion;
    DWORD pszFiltersInclusionSize;
    TCHAR** pszFiltersExclusion;
    DWORD pszFiltersExclusionSize;
    TCHAR AppNameIncludeFilters[MAX_PATH];
    TCHAR AppNameExcludeFilters[MAX_PATH];
    TCHAR AppParentIDFilters[MAX_PATH];

    void RefreshProcessesList();
    void SaveFiltersSettings();
    void FreeMemory();
    void ReloadOptions();
    void StoreOptions();
    void ReSelectProcess();

public:
    DWORD* pdwFiltersCurrentPorcessID;
    DWORD pdwFiltersCurrentPorcessIDSize;

    DWORD* pdwFiltersNewPorcessIDToWatch;
    DWORD pdwFiltersNewPorcessIDToWatchSize;
    DWORD* pdwFiltersPorcessIDToRelease;
    DWORD pdwFiltersPorcessIDToReleaseSize;

    CFilters();
    ~CFilters();
    INT_PTR ShowFilterDialog(HINSTANCE hInstance,HWND hWndDialog);
    BOOL DoesProcessNameMatchFilters(TCHAR* ProcessName);
    BOOL DoesParentIDMatchFilters(DWORD dwParentID);
};

