/**
 ****************************************************************************
 * <P> XML.c - XML parser test example for cross-plateform version </P>
 * @version     V1.15
 *
 * @author      Frank Vanden Berghen
 *
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License version 2.1 as published by the Free Software Foundation
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 ****************************************************************************
 */
#ifdef WIN32
#define _CRT_SECURE_NO_DEPRECATE
#endif

#include <stdio.h>
#include "xmlParser.h"
#include <string>
#include <iostream>
using namespace std;

int main(int argc, char **argv)
{


  int long x=5;
  string s=new string(x);
  // We create in memory from scratch the following XML structure:
  //  <?xml version="1.0"?>
  //      <body> Hello universe. </body>
  // ... and we transform it into a standard C string that is printed on screen.
  XMLNode xMainNode=XMLNode::createXMLTopNode();
  XMLNode xNode=xMainNode.addChild(stringDup("xml"),TRUE); 
  xNode.addAttribute(stringDup("version"),stringDup("1.0"));
  xNode=xNode.addChild(stringDup("Skype_UDP_log"));
  xNode.addAttribute(stringDup("timestamp"),stringDup("16/06/2006"));
  xNode=xNode.addChild(stringDup("udp_stream_info"));
  xNode.addAttribute(stringDup("ip"),stringDup("10.0.0.1"));

  xNode.addAttribute(stringDup("total_packets"),stringDup("125"));
  xNode.addAttribute(stringDup("total_packets_in"),stringDup("100"));
  xNode.addAttribute(stringDup("total_packets_out"),stringDup("25"));
  XMLNode xNode1=xNode.addChild(stringDup("packet"));
  xNode1.addAttribute(stringDup("id"),stringDup("1"));
  xNode1.addAttribute(stringDup("port"),stringDup("456"));
  xNode1.addAttribute(stringDup("len"),stringDup("126"));
  xNode1.addAttribute(stringDup("mode"),stringDup("out"));

  XMLNode xNode2=xNode.addChild(stringDup("packet"));
  xNode2.addAttribute(stringDup("id"),stringDup("2"));
  xNode2.addAttribute(stringDup("port"),stringDup("346"));
  xNode2.addAttribute(stringDup("len"),stringDup("126"));
  xNode2.addAttribute(stringDup("mode"),stringDup("in"));

  int i=0;
  char *t=xMainNode.getChildNode(_T("Extension")).createXMLString(true,&i);
	
  t=xMainNode.createXMLString(true);
  printf("XMLString created from scratch:\n%s",t);
  FILE *log=fopen( "udp_log.xml", "w+" );
  fprintf(log,t);
  fclose(log);
  free(t);

  return 0;
}
