;Definizioni delle macro usate nel progetto

;-------------------macro per segnalare errore----------------------------------------------------
SendError		MACRO   LowError,HighError

					bsf		STAPRO,ERR

					SendValue	ERRORE
					SendValue	LowError
					SendValue	HighError

                   ENDM
;--------------------fine macro per segnalare errore---------------------------------------------------

;--------------------macro per spedire un valore tramite seriale---------------------------------------------------
SendValue		MACRO	Value

					movlw	Value
					movwf	TXREG
					call	TxWait

				ENDM
;--------------------fine macro per spedire un valore tramite seriale---------------------------------------------------

;--------------------macro che ritorna *(vettore + indice)---------------------------------------------------
;alla fine ho FSR che punta al indice registro dopo vettore.
;In C equivale a *(vettore+indice) == vettore[indice]

Ptr		MACRO	vettore, indice

			movlw	indice
			movwf	FSR					;FSR punta al registro indice
			movf	INDF, w
			addlw	vettore				;accedo all' elemento vettore[indice]
			movwf	FSR					;punta al registro vettore[indice]

		ENDM			
;---------------------fine macro che ritorna *(vettore + indice)--------------------------------------------------

;---------------------macro che depolarizza i bit 7-6 del byte biased--------------------------------------------------
Unbiased_coppia_4		MACRO

	btfss	INDF, 7
	goto	bit7_0
bit7_1
	btfss	INDF, 6
	goto	bit76_10	
bit76_11
	goto 	coppia_3				;per avere tutti i bit unbiased e avere una sequenza corretta da trasmettere elimino questa coppia
bit7_0
	btfss	INDF, 6
bit76_00
	goto 	coppia_3				;per avere tutti i bit unbiased e avere una sequenza corretta da trasmettere elimino questa coppia

bit76_01							;memorizza 0
	Ptr		byte_unbiased, bit_uno
	;non serve azzerare byte_unbiased prima di usarlo perch gli shift eliminano i valori precedenti e li sovrascrivono

	bcf		STATUS,C				;prepararo il byte inserendo uno 0 nella posizione opportuna
	rlf		INDF,f					;moltiplico per 2 il numero ottenuto e aggiungo 0: mi permette di convertire 8 bit in un byte
	goto	prepara_per_nuovi_dati_4

bit76_10							;memorizza 1
	Ptr		byte_unbiased, bit_uno
	;ora ho FSR che punta al bit_uno registro dopo byte_unbiased, in un pseudolinguaggio C equivale a *(byte_unbiased+bit_uno) == byte_unbiased[bit_uno]
	;non serve azzerare byte_unbiased prima di usarlo perch gli shift eliminano i valori precedenti e li sovrascrivono

	bsf		STATUS,C				;prepararo il byte inserendo un 1 nella posizione opportuna
	rlf		INDF,f					;moltiplico per 2 il numero ottenuto e aggiungo 1: mi permette di convertire 8 bit in un byte

prepara_per_nuovi_dati_4
	movlw	cnt_bit
	movwf	FSR						;FSR punta a cnt_bit
	incf 	INDF, f					;lo incremento: conto i bit letti

	btfss	INDF, 3					;se il 3 bit  settato vuol dire che ho letto 8 bit --> il byte  pronto
	goto	ripristina_FSR_4

	clrf	INDF					;azzero il contatore di bit per prepararlo alla lettura di un nuovo byte
	movlw	bit_uno
	movwf	FSR						;FSR punta a bit_uno
	incf 	INDF, f					;incremento bit_uno cos il prossimo byte ripulito di fino lo scrivo al posto giusto
									;non ho problemi di buffer overflow perch al massimo i byte ripuliti di fino sono 32/2 = 16

ripristina_FSR_4
	Ptr		byte_biased, byteletti	;FSR punta al registro n che contiene l' n-esimo byte biased random letto	
									;in un pseudolinguaggio equivale a byte_biased[byteletti]

                   ENDM
;---------------------fine macro che depolarizza i bit 7-6 del byte biased--------------------------------------------------

;---------------------macro che depolarizza i bit 5-4 del byte biased--------------------------------------------------
Unbiased_coppia_3		MACRO

	btfss	INDF, 5
	goto	bit5_0
bit5_1
	btfss	INDF, 4
	goto	bit54_10	
bit54_11
	goto 	coppia_2				;per avere tutti i bit unbiased e avere una sequenza corretta da trasmettere elimino questa coppia
bit5_0
	btfss	INDF, 4
bit54_00
	goto 	coppia_2				;per avere tutti i bit unbiased e avere una sequenza corretta da trasmettere elimino questa coppia
	
bit54_01							;memorizza 0
	Ptr		byte_unbiased, bit_uno
	;ora ho FSR che punta al bit_uno registro dopo byte_unbiased, in un pseudolinguaggio C equivale a *(byte_unbiased+bit_uno) == byte_unbiased[bit_uno]
	;non serve azzerare byte_unbiased prima di usarlo perch gli shift eliminano i valori precedenti e li sovrascrivono

	bcf		STATUS,C				;prepararo il byte inserendo uno 0 nella posizione opportuna
	rlf		INDF,f					;moltiplico per 2 il numero ottenuto e aggiungo 0: mi permette di convertire 8 bit in un byte
	goto	prepara_per_nuovi_dati_3

bit54_10							;memorizza 1
	Ptr		byte_unbiased, bit_uno
	;ora ho FSR che punta al bit_uno registro dopo byte_unbiased, in un pseudolinguaggio C equivale a *(byte_unbiased+bit_uno) == byte_unbiased[bit_uno]
	;non serve azzerare byte_unbiased prima di usarlo perch gli shift eliminano i valori precedenti e li sovrascrivono

	bsf		STATUS,C				;prepararo il byte inserendo un 1 nella posizione opportuna
	rlf		INDF,f					;moltiplico per 2 il numero ottenuto e aggiungo 1: mi permette di convertire 8 bit in un byte

prepara_per_nuovi_dati_3
	movlw	cnt_bit
	movwf	FSR						;FSR punta a cnt_bit
	incf 	INDF, f					;lo incremento: conto i bit letti

	btfss	INDF, 3					;se il 3 bit  settato vuol dire che ho letto 8 bit --> il byte  pronto
	goto	ripristina_FSR_3

	clrf	INDF					;azzero il contatore di bit per prepararlo alla lettura di un nuovo byte
	movlw	bit_uno
	movwf	FSR						;FSR punta a bit_uno
	incf 	INDF, f					;incremento bit_uno cos il prossimo byte ripulito di fino lo scrivo al posto giusto
									;non ho problemi di buffer overflow perch al massimo i byte ripuliti di fino sono 32/2 = 16

ripristina_FSR_3
	Ptr		byte_biased, byteletti	;FSR punta al registro n che contiene l' n-esimo byte biased random letto	
									;in un pseudolinguaggio equivale a byte_biased[byteletti]

                   ENDM
;---------------------fine macro che depolarizza i bit 5-4 del byte biased--------------------------------------------------

;---------------------macro che depolarizza i bit 3-2 del byte biased--------------------------------------------------
Unbiased_coppia_2		MACRO

	btfss	INDF, 3
	goto	bit3_0
bit3_1
	btfss	INDF, 2
	goto	bit32_10	
bit32_11
	goto 	coppia_1				;per avere tutti i bit unbiased e avere una sequenza corretta da trasmettere elimino questa coppia
bit3_0
	btfss	INDF, 2
bit32_00
	goto 	coppia_1				;per avere tutti i bit unbiased e avere una sequenza corretta da trasmettere elimino questa coppia

bit32_01							;memorizza 0
	Ptr		byte_unbiased, bit_uno
	;ora ho FSR che punta al bit_uno registro dopo byte_unbiased, in un pseudolinguaggio C equivale a *(byte_unbiased+bit_uno) == byte_unbiased[bit_uno]
	;non serve azzerare byte_unbiased prima di usarlo perch gli shift eliminano i valori precedenti e li sovrascrivono

	bcf		STATUS,C				;prepararo il byte inserendo uno 0 nella posizione opportuna
	rlf		INDF,f					;moltiplico per 2 il numero ottenuto e aggiungo 0: mi permette di convertire 8 bit in un byte
	goto	prepara_per_nuovi_dati_2

bit32_10							;memorizza 1
	Ptr		byte_unbiased, bit_uno
	;ora ho FSR che punta al bit_uno registro dopo byte_unbiased, in un pseudolinguaggio C equivale a *(byte_unbiased+bit_uno) == byte_unbiased[bit_uno]
	;non serve azzerare byte_unbiased prima di usarlo perch gli shift eliminano i valori precedenti e li sovrascrivono

	bsf		STATUS,C				;prepararo il byte inserendo un 1 nella posizione opportuna
	rlf		INDF,f					;moltiplico per 2 il numero ottenuto e aggiungo 1: mi permette di convertire 8 bit in un byte

prepara_per_nuovi_dati_2
	movlw	cnt_bit
	movwf	FSR						;FSR punta a cnt_bit
	incf 	INDF, f					;lo incremento: conto i bit letti

	btfss	INDF, 3					;se il 3 bit  settato vuol dire che ho letto 8 bit --> il byte  pronto
	goto	ripristina_FSR_2

	clrf	INDF					;azzero il contatore di bit per prepararlo alla lettura di un nuovo byte
	movlw	bit_uno
	movwf	FSR						;FSR punta a bit_uno
	incf 	INDF, f					;incremento bit_uno cos il prossimo byte ripulito di fino lo scrivo al posto giusto
									;non ho problemi di buffer overflow perch al massimo i byte ripuliti di fino sono 32/2 = 16

ripristina_FSR_2
	Ptr		byte_biased, byteletti	;FSR punta al registro n che contiene l' n-esimo byte biased random letto	
									;in un pseudolinguaggio equivale a byte_biased[byteletti]

                   ENDM
;---------------------fine macro che depolarizza i bit 3-2 del byte biased--------------------------------------------------

;---------------------macro che depolarizza i bit 1-0 del byte biased--------------------------------------------------
Unbiased_coppia_1		MACRO

	btfss	INDF, 1
	goto	bit1_0
bit1_1
	btfss	INDF, 0
	goto	bit10_10	
bit10_11
	goto 	byte_successivo			;per avere tutti i bit unbiased e avere una sequenza corretta da trasmettere elimino questa coppia
bit1_0
	btfss	INDF, 0
bit10_00
	goto 	byte_successivo			;per avere tutti i bit unbiased e avere una sequenza corretta da trasmettere elimino questa coppia

bit10_01							;memorizza 0
	Ptr		byte_unbiased, bit_uno
	;ora ho FSR che punta al bit_uno registro dopo byte_unbiased, in un pseudolinguaggio C equivale a *(byte_unbiased+bit_uno) == byte_unbiased[bit_uno]
	;non serve azzerare byte_unbiased prima di usarlo perch gli shift eliminano i valori precedenti e li sovrascrivono
	
	bcf		STATUS,C				;prepararo il byte inserendo uno 0 nella posizione opportuna
	rlf		INDF,f					;moltiplico per 2 il numero ottenuto e aggiungo 0: mi permette di convertire 8 bit in un byte
	goto	prepara_per_nuovi_dati_1

bit10_10							;memorizza 1
	Ptr		byte_unbiased, bit_uno
	;ora ho FSR che punta al bit_uno registro dopo byte_unbiased, in un pseudolinguaggio C equivale a *(byte_unbiased+bit_uno) == byte_unbiased[bit_uno]
	;non serve azzerare byte_unbiased prima di usarlo perch gli shift eliminano i valori precedenti e li sovrascrivono

	bsf		STATUS,C				;prepararo il byte inserendo un 1 nella posizione opportuna
	rlf		INDF,f					;moltiplico per 2 il numero ottenuto e aggiungo 1: mi permette di convertire 8 bit in un byte

prepara_per_nuovi_dati_1
	movlw	cnt_bit
	movwf	FSR						;FSR punta a cnt_bit
	incf 	INDF, f					;lo incremento: conto i bit letti

	btfss	INDF, 3					;se il 3 bit  settato vuol dire che ho letto 8 bit --> il byte  pronto
	goto	ripristina_FSR_1

	clrf	INDF					;azzero il contatore di bit per prepararlo alla lettura di un nuovo byte
	movlw	bit_uno
	movwf	FSR						;FSR punta a bit_uno
	incf 	INDF, f					;incremento bit_uno cos il prossimo byte ripulito di fino lo scrivo al posto giusto
									;non ho problemi di buffer overflow perch al massimo i byte ripuliti di fino sono 32/2 = 16

ripristina_FSR_1
	Ptr		byte_biased, byteletti	;FSR punta al registro n che contiene l' n-esimo byte biased random letto	
									;in un pseudolinguaggio equivale a byte_biased[byteletti]

                   ENDM
;---------------------fine macro che depolarizza i bit 1-0 del byte biased--------------------------------------------------